{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": "/usr/bin/keg",
            "id": "#analyze.cwl",
            "arguments": [
                "-a",
                "analyze",
                "-T",
                "60",
                "-o",
                "output_file"
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "prefix": "-i",
                        "itemSeparator": " ",
                        "separate": true,
                        "position": 1
                    },
                    "id": "#analyze.cwl/analyze/input_files"
                }
            ],
            "pegasus:executableInfo": {
                "namespace": "pegasus",
                "version": "v4.0",
                "installed": true,
                "arch": "x86",
                "os": "linux",
                "pfn": {
                    "url": "file:///usr/bin/keg",
                    "site": "TestCluster"
                }
            },
            "outputs": [
                {
                    "type": "File",
                    "id": "#analyze.cwl/analyze/analysis_file"
                }
            ]
        },
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/workflow_input_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/j4/analysis_file",
                    "id": "#main/workflow_output_file"
                }
            ],
            "steps": [
                {
                    "id": "#main/j1",
                    "run": "#preprocess.cwl",
                    "in": [
                        {
                            "source": "#main/workflow_input_file",
                            "id": "#main/j1/input_file"
                        }
                    ],
                    "out": [
                        "#main/j1/output_file_1",
                        "#main/j1/output_file_2"
                    ],
                    "https://pegasus.isi.edu#invokes": {
                        "start": [
                            "/pegasus/libexec/notification/email -t notify@example.com"
                        ],
                        "at_end": [
                            "/pegasus/libexec/notification/email -t notify@example.com"
                        ]
                    },
                    "https://pegasus.isi.edu#jobInfo": {
                        "namespace": "pegasus",
                        "name": "#main/j1/preprocess",
                        "version": 4.0
                    },
                    "https://pegasus.isi.edu#jobMetadata": {
                        "time": 60
                    },
                    "https://pegasus.isi.edu#fileTransfer": [
                        "output_file_1",
                        "output_file_2"
                    ],
                    "https://pegasus.isi.edu#fileRegister": [
                        "output_file_1",
                        "output_file_2"
                    ]
                },
                {
                    "id": "#main/j2",
                    "run": "#findrange.cwl",
                    "in": [
                        {
                            "source": "#main/j1/output_file_1",
                            "id": "#main/j2/input_file"
                        }
                    ],
                    "out": [
                        "#main/j2/output_file"
                    ],
                    "https://pegasus.isi.edu#invokes": {
                        "start": [
                            "/pegasus/libexec/notification/email -t notify@example.com"
                        ],
                        "at_end": [
                            "/pegasus/libexec/notification/email -t notify@example.com"
                        ]
                    },
                    "https://pegasus.isi.edu#jobInfo": {
                        "namespace": "pegasus",
                        "name": "#main/j2/findrange",
                        "version": 4.0
                    },
                    "https://pegasus.isi.edu#jobMetadata": {
                        "time": 60
                    },
                    "https://pegasus.isi.edu#fileTransfer": [
                        "output_file"
                    ],
                    "https://pegasus.isi.edu#fileRegister": [
                        "output_file"
                    ]
                },
                {
                    "id": "#main/j3",
                    "run": "#findrange.cwl",
                    "in": [
                        {
                            "source": "#main/j1/output_file_1",
                            "id": "#main/j3/input_file"
                        }
                    ],
                    "out": [
                        "#main/j3/output_file"
                    ],
                    "https://pegasus.isi.edu#invokes": {
                        "start": [
                            "/pegasus/libexec/notification/email -t notify@example.com"
                        ],
                        "at_end": [
                            "/pegasus/libexec/notification/email -t notify@example.com"
                        ]
                    },
                    "https://pegasus.isi.edu#jobInfo": {
                        "namespace": "pegasus",
                        "name": "#main/j3/findrange",
                        "version": 4.0
                    },
                    "https://pegasus.isi.edu#jobMetadata": {
                        "time": 60
                    },
                    "https://pegasus.isi.edu#fileTransfer": [
                        "output_file"
                    ],
                    "https://pegasus.isi.edu#fileRegister": [
                        "output_file"
                    ]
                },
                {
                    "id": "#main/j4",
                    "run": "#analyze.cwl",
                    "in": [
                        {
                            "source": [
                                "#main/j2/output_file",
                                "#main/j3/output_file"
                            ],
                            "id": "#main/j4/input_files"
                        }
                    ],
                    "out": [
                        "#main/j4/analysis_file"
                    ],
                    "https://pegasus.isi.edu#invokes": {
                        "start": [
                            "/pegasus/libexec/notification/email -t notify@example.com"
                        ],
                        "at_end": [
                            "/pegasus/libexec/notification/email -t notify@example.com"
                        ]
                    },
                    "https://pegasus.isi.edu#jobInfo": {
                        "namespace": "pegasus",
                        "name": "#main/j4/analyze",
                        "version": 4.0
                    },
                    "https://pegasus.isi.edu#jobMetadata": {
                        "time": 60
                    },
                    "https://pegasus.isi.edu#fileTransfer": [
                        "analysis_file"
                    ],
                    "https://pegasus.isi.edu#fileRegister": [
                        "analysis_file"
                    ]
                }
            ],
            "id": "#main",
            "https://pegasus.isi.edu#workflowMetadata": {
                "name": "#main/diamond",
                "createdBy": "Karan Vahi"
            },
            "https://pegasus.isi.edu#invokes": {
                "start": [
                    "/pegasus/libexec/notification/email -t notify@example.com"
                ],
                "at_end": [
                    "/pegasus/libexec/notification/email -t notify@example.com"
                ]
            }
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "/usr/bin/keg",
            "id": "#findrange.cwl",
            "arguments": [
                "-a",
                "findrange",
                "-T",
                "60",
                "-o",
                "output_file"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-i",
                        "separate": true,
                        "position": 1
                    },
                    "id": "#findrange.cwl/findrange/input_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#findrange.cwl/findrange/output_file"
                }
            ],
            "pegasus:executableInfo": {
                "namespace": "pegasus",
                "version": "v4.0",
                "installed": true,
                "arch": "x86",
                "os": "linux",
                "pfn": {
                    "url": "file:///usr/bin/keg",
                    "site": "TestCluster"
                }
            }
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "/usr/bin/keg",
            "id": "#preprocess.cwl",
            "arguments": [
                "-a",
                "preprocesss",
                "-T",
                "60",
                "-o",
                "output_file_1",
                "output_file_2"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-i",
                        "separate": true,
                        "position": 1
                    },
                    "id": "#preprocess.cwl/preprocess/input_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#preprocess.cwl/preprocess/output_file_1"
                },
                {
                    "type": "File",
                    "id": "#preprocess.cwl/preprocess/output_file_2"
                }
            ],
            "pegasus:executableInfo": {
                "namespace": "pegasus",
                "version": "v4.0",
                "installed": true,
                "arch": "x86",
                "os": "linux",
                "size": 2048,
                "pfn": {
                    "url": "file:///usr/bin/keg",
                    "site": "TestCluster"
                }
            }
        }
    ],
    "cwlVersion": "v1.0",
    "$namespaces": {
        "pegasus": "https://pegasus.isi.edu#"
    }
}
